#!/bin/bash

write_uboot_image() {
   ntries=0
   #First make sure the file on disk is correct
   /usr/bin/od --strings=6 $uboot_image | /bin/grep "$uboot_version"
   nreturn=$?
   if [ ! $nreturn -eq 0 ]; then
      echo "`date` Incorrect uboot image file $uboot_image"
   else
    while [ "$ntries" -lt 3 ]; do
      if [ ! -e "$uboot_image" ]; then
         echo "`date` Missing uboot image file $uboot_image"
         break
      fi
      /nn/bin/eraseall /dev/mtd7
      /bin/cat $uboot_image | /nn/bin/eengine -1 > /dev/mtd7
      /bin/cat /dev/mtd7 | /nn/bin/eengine -1 > /tmp/uboot.image
      /usr/bin/od --strings=6 /tmp/uboot.image | /bin/grep "$uboot_version"
      nreturn=$?
      if [ $nreturn -eq 0 ]; then
         echo "`date` uboot flash image updated"
         break
      else
         /nn/bin/eraseall /dev/mtd7
         /bin/cat $uboot_image | /nn/bin/eengine -1 > /dev/mtd7
         (( ntries += 1 ))
      fi
    done

    if [ "$ntries" -eq 3 ]; then
      echo "`date` Error: uboot flash image NOT updated successfully"
    fi
      
   fi
}

ntries=0
nreturn=0

if [ -f /proc/nn/boardtype ] && [ "`cat /proc/nn/boardtype`" == "2" ]; then
   uboot_version="CSC U-Boot 2.06.4"
   uboot_image=/nn/images/uboot/csc_r2_u-boot.bin
else
   uboot_version="U-Boot 2.06.4"
   uboot_image=/nn/images/uboot/csc_r1_u-boot.bin
fi

write_uboot_image

exit 0
